scala.xml.include.sax

# XIncludeFilter

#### class XIncludeFilter extends XMLFilterImpl

This is a SAX filter which resolves all XInclude include elements before passing them on to the client application. Currently this class has the following known deviation from the XInclude specification:

- XPointer is not supported.

Furthermore, I would definitely use a new instance of this class for each document you want to process. I doubt it can be used successfully on multiple documents. Furthermore, I can virtually guarantee that this class is not thread safe. You have been warned.

Since this class is not designed to be subclassed, and since I have not yet considered how that might affect the methods herein or what other protected methods might be needed to support subclasses, I have declared this class final. I may remove this restriction later, though the use-case for subclassing is weak. This class is designed to have its functionality extended via a a horizontal chain of filters, not a vertical hierarchy of sub and superclasses.

To use this class:

- Construct an `XIncludeFilter` object with a known base URL
- Pass the `XMLReader` object from which the raw document will be read to the `setParent()` method of this object.
- Pass your own `ContentHandler` object to the `setContentHandler()` method of this object. This is the object which will receive events from the parsed and included document.
- Optional: if you wish to receive comments, set your own `LexicalHandler` object as the value of this object's http://xml.org/sax/properties/lexical-handler property. Also make sure your `LexicalHandler` asks this object for the status of each comment using `insideIncludeElement` before doing anything with the comment.
- Pass the URL of the document to read to this object's `parse()` method

e.g.

    XIncludeFilter includer = new XIncludeFilter(base);
     includer.setParent(parser);
     includer.setContentHandler(new SAXXIncluder(System.out));
     includer.parse(args[i]);

translated from Elliotte Rusty Harold's Java source

Source
  XIncludeFilter.scala

Linear Supertypes
XMLFilterImpl, ErrorHandler, ContentHandler, DTDHandler, EntityResolver, XMLFilter, XMLReader, AnyRef, Any
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. Hide All
2. Show all

1. XIncludeFilter
2. XMLFilterImpl
3. ErrorHandler
4. ContentHandler
5. DTDHandler
6. EntityResolver
7. XMLFilter
8. XMLReader
9. AnyRef
10. Any

Visibility

1. Public
2. All

### Instance Constructors

1. #### new XIncludeFilter()

### Value Members

1. #### final def !=(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

2. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     Any

3. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types.

   Equivalent to `x.hashCode` except for boxed numeric types. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

4. #### final def ==(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

5. #### final def ==(arg0: Any): Boolean

   Test two objects for equality.

   Test two objects for equality.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     Any

6. #### final val XINCLUDE_NAMESPACE: java.lang.String("http://www.w3.org/2001/XInclude")

7. #### final def asInstanceOf[T0]: T0

   Cast the receiver object to be of type `T0`.

   Cast the receiver object to be of type `T0`.

   Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

   returns

     the receiver object.

   Definition Classes
     Any
   Exceptions thrown
     ClassCastException

     if the receiver object is not an instance of the erasure of type `T0`.

8. #### def characters(ch: Array[Char], start: Int, length: Int): Unit

   Definition Classes
     XIncludeFilter → XMLFilterImpl → ContentHandler

9. #### def clone(): AnyRef

   Create a copy of the receiver object.

   Create a copy of the receiver object.

   The default implementation of the `clone` method is platform dependent.

   returns

     a copy of the receiver object.

   Attributes
     protected[lang]
   Definition Classes
     AnyRef
   Annotations
     @throws()
   Note

     not specified by SLS as a member of AnyRef

10. #### def endDocument(): Unit

    Definition Classes
      XIncludeFilter → XMLFilterImpl → ContentHandler

11. #### def endElement(uri: String, localName: String, qName: String): Unit

    Definition Classes
      XIncludeFilter → XMLFilterImpl → ContentHandler

12. #### def endPrefixMapping(prefix: String): Unit

    Definition Classes
      XIncludeFilter → XMLFilterImpl → ContentHandler

13. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

14. #### def equals(arg0: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. See equals in Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any

15. #### def error(arg0: SAXParseException): Unit

    Definition Classes
      XMLFilterImpl → ErrorHandler
    Annotations
      @throws()

16. #### def fatalError(arg0: SAXParseException): Unit

    Definition Classes
      XMLFilterImpl → ErrorHandler
    Annotations
      @throws()

17. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws()
    Note

      not specified by SLS as a member of AnyRef

18. #### final def getClass(): java.lang.Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

19. #### def getContentHandler(): ContentHandler

    Definition Classes
      XMLFilterImpl → XMLReader

20. #### def getDTDHandler(): DTDHandler

    Definition Classes
      XMLFilterImpl → XMLReader

21. #### def getEntityResolver(): EntityResolver

    Definition Classes
      XMLFilterImpl → XMLReader

22. #### def getErrorHandler(): ErrorHandler

    Definition Classes
      XMLFilterImpl → XMLReader

23. #### def getFeature(arg0: String): Boolean

    Definition Classes
      XMLFilterImpl → XMLReader
    Annotations
      @throws() @throws()

24. #### def getParent(): XMLReader

    Definition Classes
      XMLFilterImpl → XMLFilter

25. #### def getProperty(arg0: String): AnyRef

    Definition Classes
      XMLFilterImpl → XMLReader
    Annotations
      @throws() @throws()

26. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any

27. #### def ignorableWhitespace(ch: Array[Char], start: Int, length: Int): Unit

    Definition Classes
      XIncludeFilter → XMLFilterImpl → ContentHandler

28. #### def insideIncludeElement(): Boolean

    This utility method returns true if and only if this reader is currently inside a non-empty include element.

    This utility method returns true if and only if this reader is currently inside a non-empty include element. (This is not the same as being inside the node set which replaces the include element.) This is primarily needed for comments inside include elements. It must be checked by the actual LexicalHandler to see whether a comment is passed or not.

    returns

      boolean

29. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

30. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

31. #### def notationDecl(arg0: String, arg1: String, arg2: String): Unit

    Definition Classes
      XMLFilterImpl → DTDHandler
    Annotations
      @throws()

32. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

33. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

34. #### def parse(arg0: String): Unit

    Definition Classes
      XMLFilterImpl → XMLReader
    Annotations
      @throws() @throws()

35. #### def parse(arg0: InputSource): Unit

    Definition Classes
      XMLFilterImpl → XMLReader
    Annotations
      @throws() @throws()

36. #### def processingInstruction(target: String, data: String): Unit

    Definition Classes
      XIncludeFilter → XMLFilterImpl → ContentHandler

37. #### def resolveEntity(arg0: String, arg1: String): InputSource

    Definition Classes
      XMLFilterImpl → EntityResolver
    Annotations
      @throws() @throws()

38. #### def setContentHandler(arg0: ContentHandler): Unit

    Definition Classes
      XMLFilterImpl → XMLReader

39. #### def setDTDHandler(arg0: DTDHandler): Unit

    Definition Classes
      XMLFilterImpl → XMLReader

40. #### def setDocumentLocator(locator: Locator): Unit

    Definition Classes
      XIncludeFilter → XMLFilterImpl → ContentHandler

41. #### def setEntityResolver(arg0: EntityResolver): Unit

    Definition Classes
      XMLFilterImpl → XMLReader

42. #### def setErrorHandler(arg0: ErrorHandler): Unit

    Definition Classes
      XMLFilterImpl → XMLReader

43. #### def setFeature(arg0: String, arg1: Boolean): Unit

    Definition Classes
      XMLFilterImpl → XMLReader
    Annotations
      @throws() @throws()

44. #### def setParent(arg0: XMLReader): Unit

    Definition Classes
      XMLFilterImpl → XMLFilter

45. #### def setProperty(arg0: String, arg1: Any): Unit

    Definition Classes
      XMLFilterImpl → XMLReader
    Annotations
      @throws() @throws()

46. #### def skippedEntity(name: String): Unit

    Definition Classes
      XIncludeFilter → XMLFilterImpl → ContentHandler

47. #### def startDocument(): Unit

    Definition Classes
      XIncludeFilter → XMLFilterImpl → ContentHandler

48. #### def startElement(uri: String, localName: String, qName: String, atts1: Attributes): Unit

    Definition Classes
      XIncludeFilter → XMLFilterImpl → ContentHandler

49. #### def startPrefixMapping(prefix: String, uri: String): Unit

    Definition Classes
      XIncludeFilter → XMLFilterImpl → ContentHandler

50. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

51. #### def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      AnyRef → Any

52. #### def unparsedEntityDecl(arg0: String, arg1: String, arg2: String, arg3: String): Unit

    Definition Classes
      XMLFilterImpl → DTDHandler
    Annotations
      @throws()

53. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws()

54. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws()

55. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws()

56. #### def warning(arg0: SAXParseException): Unit

    Definition Classes
      XMLFilterImpl → ErrorHandler
    Annotations
      @throws()

### Inherited from XMLFilterImpl

### Inherited from ErrorHandler

### Inherited from ContentHandler

### Inherited from DTDHandler

### Inherited from EntityResolver

### Inherited from XMLFilter

### Inherited from XMLReader

### Inherited from AnyRef

### Inherited from Any